package org.bdware.sc.handler;

import com.google.gson.JsonPrimitive;
import org.bdware.doip.codec.doipMessage.DoipMessage;
import org.bdware.doip.codec.operations.BasicOperations;
import org.bdware.doip.endpoint.server.RepositoryHandler;
import org.bdware.sc.ContractProcess;
import org.bdware.sc.ContractResult;
import org.bdware.sc.node.ContractNode;
import org.bdware.sc.node.FunctionNode;
import org.bdware.sc.node.YjsType;

public class DOOPRepositoryHandler implements RepositoryHandler {
    private ContractNode cn;
    private boolean isDoipModule;

    public DOOPRepositoryHandler(ContractNode cn) {
        if(cn.getYjsType() == YjsType.DoipModule) {
            isDoipModule = true;
            this.cn = cn;
        }
    }

    @Override
    public DoipMessage handleHello(DoipMessage request) {
        FunctionNode fn = cn.getDoipOperation(BasicOperations.Hello);
        ContractProcess.instance.executeContract("");
        return null;
    }

    @Override
    public DoipMessage handleListOps(DoipMessage request) {
        FunctionNode fn = cn.getDoipOperation(BasicOperations.ListOps);

        return null;
    }

    @Override
    public DoipMessage handleCreate(DoipMessage request) {
        FunctionNode fn = cn.getDoipOperation(BasicOperations.Create);
        return null;
    }

    @Override
    public DoipMessage handleUpdate(DoipMessage request) {
        FunctionNode fn = cn.getDoipOperation(BasicOperations.Update);
        return null;
    }

    @Override
    public DoipMessage handleDelete(DoipMessage request) {
        FunctionNode fn = cn.getDoipOperation(BasicOperations.Delete);
        return null;
    }

    @Override
    public DoipMessage handleRetrieve(DoipMessage request) {
        FunctionNode fn = cn.getDoipOperation(BasicOperations.Retrieve);
        return null;
    }

    private ContractResult invokeFunction(FunctionNode fun, BasicOperations basicOperation) {
        if (fun == null) {
            return new ContractResult(
                    ContractResult.Status.Exception,
                    new JsonPrimitive("DoipOperation " + basicOperation + " is not exists"));
        }

        return null;
    }
}
